/*
        clstrtok.h -- class wrapper for strtok()
        (C) Copyright 1995  John Webster Small
        All rights reserved
*/

#ifndef clstrtok_h
#define clstrtok_h

#ifndef cl_h
  #include "cl.h"
#endif

#ifndef cstr_h
  #include "cstr.h"
#endif

class CL_strtok : public CL<cstr>
{
    cstr _input;
    int first;
  public:
    CL_strtok(const char * input)
        : CL<cstr>(CL_ANDS), _input(input)
        , first(1)
        {}
    CL_strtok& operator()(const char * input);
    const char * tok(const char * delimiters);
    CL_strtok& parse(const char * delimiters);
    CL_strtok
        (const char * input, const char * delimiters)
        : CL<cstr>(CL_ANDS), _input(input)
        , first(1)
        { (void) parse(delimiters); }
    CL_strtok& operator()
        (const char * input, const char * delimiters);
    CL_strtok& parse
        (const char * argv[], unsigned argc);
    CL_strtok(const char * input,
        const char * argv[], unsigned argc)
        : CL<cstr>(CL_ANDS), _input(input)
        , first(1)
        { (void) parse(argv,argc); }
    CL_strtok& operator()(const char * input,
        const char * argv[], unsigned argc);
};

#endif
